package com.ep.crm.ztbx009.service.support;

package ..deTemp.1732509888473;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.ep.crm.service.webservice.sap.funW18.SapProductionmovementExecuteSoapBiz_PTBindingQSServiceStub;
import com.ep.crm.zmdm005.mapper.Zmdm005Mapper;
import com.ep.crm.zmdm019.data.Zmdm019;
import com.ep.crm.zmdm019.mapper.Zmdm019Mapper;
import com.ep.crm.zmdm019.service.IZmdm019Service;
import com.ep.crm.zmdm019.utils.Zmdm019ViewUtils;
import com.ep.crm.zmdm019.view.Zmdm019View;
import com.ep.crm.zmdm020.data.Zmdm020;
import com.ep.crm.zmdm020.data.Zmdm020Item;
import com.ep.crm.zmdm020.mapper.Zmdm020Mapper;
import com.ep.crm.zmdm020.service.IZmdm020Service;
import com.ep.crm.zmdm028.mapper.Zmdm028Mapper;
import com.ep.crm.ztbx008.data.Ztbx008;
import com.ep.crm.ztbx008.data.Ztbx008Request;
import com.ep.crm.ztbx008.mapper.Ztbx008Mapper;
import com.ep.crm.ztbx008.service.IZtbx008Service;
import com.ep.crm.ztbx009.data.SurplusSchedulingRequest;
import com.ep.crm.ztbx009.data.Ztbx009;
import com.ep.crm.ztbx009.data.Ztbx009Item;
import com.ep.crm.ztbx009.mapper.Ztbx009Mapper;
import com.ep.crm.ztbx009.service.IZtbx009Service;
import com.ep.crm.ztbx009.utils.Ztbx009ItemViewUtils;
import com.ep.crm.ztbx009.utils.Ztbx009SqlUtils;
import com.ep.crm.ztbx009.view.Ztbx009ItemView;
import com.jtg.dto.base.GoodsMovementDTO;
import com.jtg.dto.base.GoodsmvtItem;
import com.jtg.dto.execution.SapPoRouteDTO;
import com.jtg.dto.sap.FunW03.W03OrderDTO;
import com.jtg.dto.sap.FunW03.W03ResDTO;
import com.jtg.response.Result;
import com.jtg.service.base.GoodsMovementService;
import com.jtg.service.sap.W03ControlsService;
import com.jtzt.ztmes.exception.MesBusinessException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import javax.servlet.http.HttpServletRequest;
import net.sf.json.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.bouncycastle.crypto.RuntimeCryptoException;
import org.data.page.Page;
import org.data.page.PageQuery;
import org.dihua.upgradingpage.frontview.tags.SysInfoUtil;
import org.dihua.util.tools.ComUtils;
import org.dihua.util.tools.SqlTools;
import org.dihua.workflow.audits.domain.IAuditsDomain;
import org.dihua.workflow.utils.SqlParserUtil;
import org.epvision.bsp.base.id.dao.jdbc.IncrementDao;
import org.epvision.util.Page;
import org.epvision.util.RowSelection;
import org.epvision.waf.ComponentFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

@Service
@CrossOrigin
@RequestMapping({"restztbx009"})
public class Ztbx009ServiceImpl implements IZtbx009Service {
  private static Log log = LogFactory.getLog(com.ep.crm.ztbx009.service.support.Ztbx009ServiceImpl.class);
  
  @Autowired
  private Ztbx009Mapper ztbx009Mapper;
  
  @Autowired
  private Ztbx008Mapper ztbx008Mapper;
  
  @Autowired
  private IZtbx008Service ztbx008Service;
  
  @Autowired
  private IZmdm019Service zmdm019Service;
  
  @Autowired
  private Zmdm019Mapper zmdm019Mapper;
  
  @Autowired
  private W03ControlsService w03ControlsService;
  
  @Autowired
  private IZmdm020Service zmdm020Service;
  
  @Autowired
  private Zmdm020Mapper zmdm020Mapper;
  
  @Autowired
  private GoodsMovementService goodsMovementService;
  
  @Autowired
  private Zmdm028Mapper zmdm028Mapper;
  
  @Autowired
  private Zmdm005Mapper zmdm005Mapper;
  
  @RequestMapping(path = {"/deleteZtbx009.do"}, method = {RequestMethod.POST, RequestMethod.GET})
  @ResponseBody
  public void deleteZtbx009(@RequestParam(value = "fcodeid", required = true) String fcodeid) {
    this.ztbx009Mapper.deleteZtbx009ItemByMainCodeId(fcodeid);
    this.ztbx009Mapper.deleteZtbx009(fcodeid);
  }
  
  @RequestMapping(path = {"/deleteAuditZtbx009.do"}, method = {RequestMethod.POST, RequestMethod.GET})
  @ResponseBody
  public void deleteZtbx009(@RequestParam(value = "fcodeid", required = true) String fcodeid, String toallauditchangevalues) {
    this.ztbx009Mapper.deleteZtbx009ItemByMainCodeId(fcodeid);
    this.ztbx009Mapper.deleteZtbx009(fcodeid);
    ((IAuditsDomain)IAuditsDomain.class.cast(ComponentFactory.getBean("auditsDomain"))).saveMainTableDeleteAuditInfo(fcodeid, toallauditchangevalues);
  }
  
  @RequestMapping(path = {"/getZtbx009.do"}, method = {RequestMethod.POST, RequestMethod.GET})
  @ResponseBody
  public Ztbx009 getZtbx009(@RequestParam(value = "fcodeid", required = true) String fcodeid) {
    Ztbx009 ztbx009 = this.ztbx009Mapper.getZtbx009(fcodeid);
    ztbx009.setListZtbx009Item(this.ztbx009Mapper.getZtbx009ItemByMainCodeId(fcodeid));
    return ztbx009;
  }
  
  public Page getAllZtbx009(RowSelection rowSelection, Map map) {
    String sql = SqlParserUtil.getSql(map, "FCODEID", "ZTBX009");
    Page oPage = PageQuery.getList(sql);
    Page page = ComUtils.getPage(oPage.getData(), "i$");
    page.setCount(oPage.getRowTotal());
    return page;
  }
  
  public Page getAllZtbx009_ms(RowSelection rowSelection, Map map) {
    Page oPage = PageQuery.getList(Ztbx009SqlUtils.getSqlMs(rowSelection, map));
    Page page = Ztbx009SqlUtils.getPageMs(oPage.getData());
    page.setCount(oPage.getRowTotal());
    return page;
  }
  
  @RequestMapping(path = {"/getAllZtbx009NoPage.do"}, method = {RequestMethod.POST, RequestMethod.GET})
  @ResponseBody
  public List getAllZtbx009NoPage(@RequestParam Map map) {
    List<Map> list = this.ztbx009Mapper.getList(Ztbx009SqlUtils.getSqlNoPage(map));
    return list;
  }
  
  @RequestMapping(path = {"/insertZtbx009.do"}, method = {RequestMethod.POST, RequestMethod.GET})
  @ResponseBody
  public Ztbx009 insertZtbx009(@RequestBody Ztbx009 ztbx009) {
    IncrementDao id = (IncrementDao)ComponentFactory.getBean("ZTBX009CODEID");
    IncrementDao pendingOrderId = (IncrementDao)ComponentFactory.getBean("PENDING_ORDER_ID");
    String codeid = id.nextStringValue();
    String nextPendingOrderId = pendingOrderId.nextStringValue();
    ztbx009.setFCODEID(codeid);
    ztbx009.setPENDING_ORDER_ID(nextPendingOrderId);
    ztbx009.setSALES_OFFICE("0");
    String sql = SqlTools.getInsertSql(ztbx009, "ZTBX009");
    this.ztbx009Mapper.insert(sql);
    Iterator ztbx009ItemList = ztbx009.getListZtbx009Item().iterator();
    while (ztbx009ItemList.hasNext()) {
      JSONObject jsonObject = JSONObject.fromObject(ztbx009ItemList.next());
      Ztbx009Item ztbx009Item = (Ztbx009Item)JSONObject.toBean(jsonObject, Ztbx009Item.class);
      IncrementDao itemid = (IncrementDao)ComponentFactory.getBean("ZTBX009_ITEMCODEID");
      String itemcodeid = itemid.nextStringValue();
      ztbx009Item.setFCODEID(itemcodeid);
      ztbx009Item.setMAIN_CODEID(ztbx009.getFCODEID());
      sql = SqlTools.getInsertSql(ztbx009Item, "ZTBX009_ITEM");
      this.ztbx009Mapper.insert(sql);
      Ztbx009ItemView ztbx009ItemView = Ztbx009ItemViewUtils.getZtbx009ItemView(ztbx009Item);
      ((IAuditsDomain)IAuditsDomain.class.cast(ComponentFactory.getBean("auditsDomain"))).saveItemInsertAuditInfo(ztbx009.getAllauditchangevalues(), ztbx009.getFCODEID(), ztbx009Item.getFCODEID(), ztbx009ItemView, "ZTBX009_ITEM");
    } 
    ((IAuditsDomain)IAuditsDomain.class.cast(ComponentFactory.getBean("auditsDomain"))).saveAllAuditInfo(ztbx009.getAllauditchangevalues(), ztbx009.getFCODEID());
    return ztbx009;
  }
  
  @RequestMapping(path = {"/updateZtbx009.do"}, method = {RequestMethod.POST, RequestMethod.GET})
  @ResponseBody
  public Ztbx009 updateZtbx009(@RequestBody Ztbx009 ztbx009) {
    String sql = "";
    Iterator ztbx009ItemList = ztbx009.getListZtbx009Item().iterator();
    while (ztbx009ItemList.hasNext()) {
      JSONObject jsonObject = JSONObject.fromObject(ztbx009ItemList.next());
      Ztbx009Item ztbx009Item = (Ztbx009Item)JSONObject.toBean(jsonObject, Ztbx009Item.class);
      if (!ztbx009Item.get_state().equals("removed")) {
        ztbx009Item.setMAIN_CODEID(ztbx009.getFCODEID());
        if (ztbx009Item.getFCODEID() != null && !"".equals(ztbx009Item.getFCODEID())) {
          sql = SqlTools.getUpdateSql(ztbx009Item, "ZTBX009_ITEM");
          this.ztbx009Mapper.update(sql);
          continue;
        } 
        IncrementDao itemid = (IncrementDao)ComponentFactory.getBean("ZTBX009_ITEMCODEID");
        ztbx009Item.setFCODEID(itemid.nextStringValue());
        sql = SqlTools.getInsertSql(ztbx009Item, "ZTBX009_ITEM");
        this.ztbx009Mapper.insert(sql);
        Ztbx009ItemView ztbx009ItemView = Ztbx009ItemViewUtils.getZtbx009ItemView(ztbx009Item);
        ((IAuditsDomain)IAuditsDomain.class.cast(ComponentFactory.getBean("auditsDomain"))).saveItemInsertAuditInfo(ztbx009.getAllauditchangevalues(), ztbx009.getFCODEID(), ztbx009Item.getFCODEID(), ztbx009ItemView, "ZTBX009_ITEM");
        continue;
      } 
      this.ztbx009Mapper.deleteZtbx009Item(ztbx009Item.getFCODEID());
    } 
    ((IAuditsDomain)IAuditsDomain.class.cast(ComponentFactory.getBean("auditsDomain"))).saveAllAuditInfo(ztbx009.getAllauditchangevalues(), ztbx009.getFCODEID());
    sql = SqlTools.getUpdateSql(ztbx009, "ZTBX009");
    this.ztbx009Mapper.update(sql);
    return getZtbx009(ztbx009.getFCODEID());
  }
  
  public void insertByZtbx008(String fcodeid, String type, HttpServletRequest req) {
    String time = SysInfoUtil.getSysDateTime();
    String nowUser = SysInfoUtil.getSysUserId(req);
    String userName = SysInfoUtil.getSysUserName(req);
    try {
      Ztbx008 ztbx008 = this.ztbx008Mapper.getZtbx008(fcodeid);
      if ("0".equals(type)) {
        Ztbx009 ztbx009 = new Ztbx009();
        ztbx009.setSURP_FCODEID(fcodeid);
        ztbx009.setPROD_LINE("9303");
        ztbx009.setMOUNT_TYPE("0");
        ztbx009.setSAP_PO(ztbx008.getSAP_PO());
        ztbx009.setCUST_NAME(ztbx008.getCUST_NAME());
        ztbx009.setBRAND(ztbx008.getBRAND());
        ztbx009.setSPEC(ztbx008.getSPEC());
        ztbx009.setSPEC_MAX(ztbx008.getSPEC_MAX());
        ztbx009.setSPEC_MIN(ztbx008.getSPEC_MIN());
        ztbx009.setSURP_MAT(ztbx008.getMAT());
        ztbx009.setSURP_MAT_DESC(ztbx008.getMAT_DESC());
        ztbx009.setSURP_NW(ztbx008.getSTOCK());
        ztbx009.setREVIEW_STATUS("0");
        ztbx009.setSALES_ORG(userName);
        ztbx009.setFCREATER(nowUser);
        ztbx009.setFCREATEDATE(time);
        ztbx009.setFCHANGER(nowUser);
        ztbx009.setFCHANGEDATE(time);
        ztbx009.setIS_DELETESYS("0");
        insertZtbx009(ztbx009);
        ztbx008.setREMAINING_QUANTITY("0");
        this.ztbx008Service.updateZtbx008(ztbx008);
      } else {
        Ztbx009 ztbx009 = new Ztbx009();
        ztbx009.setSURP_FCODEID(fcodeid);
        ztbx009.setPROD_LINE("9303");
        ztbx009.setMOUNT_TYPE("1");
        ztbx009.setMES_PO(ztbx008.getSAP_PO());
        ztbx009.setCUST_NAME(ztbx008.getCUST_NAME());
        ztbx009.setBRAND(ztbx008.getBRAND());
        ztbx009.setSPEC(ztbx008.getSPEC());
        ztbx009.setSPEC_MAX(ztbx008.getSPEC_MAX());
        ztbx009.setSPEC_MIN(ztbx008.getSPEC_MIN());
        ztbx009.setSURP_MAT(ztbx008.getMAT());
        ztbx009.setSURP_MAT_DESC(ztbx008.getMAT_DESC());
        ztbx009.setSURP_NW(ztbx008.getSTOCK());
        ztbx009.setREVIEW_STATUS("0");
        ztbx009.setSALES_ORG(userName);
        ztbx009.setFCREATER(nowUser);
        ztbx009.setFCREATEDATE(time);
        ztbx009.setFCHANGER(nowUser);
        ztbx009.setFCHANGEDATE(time);
        ztbx009.setIS_DELETESYS("0");
        insertZtbx009(ztbx009);
        ztbx008.setREMAINING_QUANTITY("0");
        this.ztbx008Service.updateZtbx008(ztbx008);
      } 
    } catch (Exception e) {
      e.printStackTrace();
      throw new RuntimeException(e.getMessage());
    } 
  }
  
  public String insertZtbx009ByZtbx008(SurplusSchedulingRequest request, HttpServletRequest httpServletRequest) {
    String msg = "";
    String time = SysInfoUtil.getSysDateTime();
    String nowUser = SysInfoUtil.getSysUserId(httpServletRequest);
    String userName = SysInfoUtil.getSysUserName(httpServletRequest);
    String type = request.getType();
    String orderFcodeId = request.getOrderFcodeId();
    Zmdm019 zmdm019 = this.zmdm019Mapper.getZmdm019(orderFcodeId);
    String splitWeight = request.getSplitWeight();
    Map<String, Object> splitMap = new HashMap<>();
    splitMap.put("finall", request.getLeftWeight());
    splitMap.put("orderId", zmdm019.getPO());
    splitMap.put("orderBatch", zmdm019.getPO_BATCH());
    splitMap.put("orderType", "3");
    splitMap.put("splitNum", splitWeight);
    splitMap.put("splitType", request.getSplitType());
    splitMap.put("allocWeight", request.getAllocWeight());
    splitMap.put("userId", nowUser);
    try {
      List<Ztbx008Request> ztbx008List = request.getZtbx008List();
      Ztbx009 ztbx009 = new Ztbx009();
      Zmdm019 splitZmdm019InsertRes = new Zmdm019();
      Zmdm019 saveZtbx009Form019 = new Zmdm019();
      if (type.equals("FINISHED")) {
        ztbx008List = request.getZtbx008List();
        splitZmdm019InsertRes = splitZmdm019(zmdm019, splitMap, httpServletRequest);
        if ("901".equals(splitZmdm019InsertRes.getPO_BATCH())) {
          saveZtbx009Form019 = splitZmdm019InsertRes;
        } else {
          saveZtbx009Form019 = zmdm019;
        } 
        ztbx009.setSAP_PO(saveZtbx009Form019.getPO());
        ztbx009.setMES_PO(saveZtbx009Form019.getPO_BATCH());
        ztbx009.setBRAND(saveZtbx009Form019.getINMARKNO());
        ztbx009.setPOSTING_DATE(SysInfoUtil.getSysDate());
        ztbx009.setPROD_LINE("9303");
        ztbx009.setMOUNT_TYPE("0");
        ztbx009.setREVIEW_STATUS("0");
        ztbx009.setORDER_WT(saveZtbx009Form019.getPRD_QTY());
        ztbx009.setCUST_NAME(saveZtbx009Form019.getCUST_NAME());
        ztbx009.setSURP_NW(splitMap.get("allocWeight").toString());
        ztbx009.setMAT(saveZtbx009Form019.getOUTMARKNO());
        ztbx009.setMAT_DESC(saveZtbx009Form019.getOUTMARK_DESC());
        ztbx009.setBRAND(saveZtbx009Form019.getINMARKNO());
        ztbx009.setSPEC(saveZtbx009Form019.getSPECIAL());
        ztbx009.setSALES_ORG(userName);
        ztbx009.setFCREATER(nowUser);
        ztbx009.setFCREATEDATE(time);
        ztbx009.setFCHANGER(nowUser);
        ztbx009.setFCHANGEDATE(time);
        ztbx009.setIS_DELETESYS("0");
      } else {
        splitZmdm019InsertRes = splitZmdm019(zmdm019, splitMap, httpServletRequest);
        if ("901".equals(splitZmdm019InsertRes.getPO_BATCH())) {
          saveZtbx009Form019 = splitZmdm019InsertRes;
        } else {
          saveZtbx009Form019 = zmdm019;
        } 
        ztbx009.setSAP_PO(saveZtbx009Form019.getPO());
        ztbx009.setMES_PO(saveZtbx009Form019.getPO_BATCH());
        ztbx009.setBRAND(saveZtbx009Form019.getINMARKNO());
        ztbx009.setPOSTING_DATE(SysInfoUtil.getSysDate());
        ztbx009.setPROD_LINE("9303");
        ztbx009.setMOUNT_TYPE("1");
        ztbx009.setREVIEW_STATUS("0");
        ztbx009.setORDER_WT(saveZtbx009Form019.getPRD_QTY());
        ztbx009.setCUST_NAME(saveZtbx009Form019.getCUST_NAME());
        ztbx009.setSURP_NW(splitMap.get("allocWeight").toString());
        ztbx009.setMAT(saveZtbx009Form019.getOUTMARKNO());
        ztbx009.setMAT_DESC(saveZtbx009Form019.getOUTMARK_DESC());
        ztbx009.setBRAND(saveZtbx009Form019.getINMARKNO());
        ztbx009.setSPEC(saveZtbx009Form019.getSPECIAL());
        ztbx009.setSALES_ORG(userName);
        ztbx009.setFCREATER(nowUser);
        ztbx009.setFCREATEDATE(time);
        ztbx009.setFCHANGER(nowUser);
        ztbx009.setFCHANGEDATE(time);
        ztbx009.setIS_DELETESYS("0");
      } 
      List<Ztbx009Item> listZtbx009Item = new ArrayList();
      for (Ztbx008Request ztbx008 : ztbx008List) {
        String fcodeid = ztbx008.getFcodeid();
        Ztbx008 getZtbx008 = this.ztbx008Service.getZtbx008(fcodeid);
        String remainingQuantity = getZtbx008.getREMAINING_QUANTITY();
        String oldStock = getZtbx008.getSTOCK();
        String stock = ztbx008.getStock();
        BigDecimal bgInputStock = StringUtils.isBlank(stock) ? new BigDecimal("0") : new BigDecimal(stock);
        BigDecimal oldStockBg = StringUtils.isBlank(oldStock) ? new BigDecimal("0") : new BigDecimal(oldStock);
        BigDecimal remainingQuantityBg = StringUtils.isBlank(remainingQuantity) ? new BigDecimal("0") : new BigDecimal(remainingQuantity);
        BigDecimal surpBg = oldStockBg.subtract(remainingQuantityBg);
        if (bgInputStock.compareTo(surpBg) > 0)
          throw new IllegalArgumentException("本次挂单量:" + bgInputStock.toString() + "大于剩余量,不允许挂单!"); 
        Ztbx009ItemView vi = new Ztbx009ItemView();
        vi.setT$ZTBX009_ITEM$STOCK_PK(fcodeid);
        vi.setT$ZTBX009_ITEM$SYNCZ_STATUS("0");
        vi.setT$ZTBX009_ITEM$SFC_MAT(getZtbx008.getMAT());
        vi.setT$ZTBX009_ITEM$SFC_MAT_DESC(getZtbx008.getMAT_DESC());
        vi.setT$ZTBX009_ITEM$NW(bgInputStock.toString());
        vi.setT$ZTBX009_ITEM$CURRENT_SPEC(getZtbx008.getSPEC());
        vi.setT$ZTBX009_ITEM$SFC_SAPPO(getZtbx008.getSAP_PO());
        vi.setT$ZTBX009_ITEM$SFC_CUSTNAME(getZtbx008.getCUST_NAME());
        vi.setT$ZTBX009_ITEM$BRAND(getZtbx008.getBRAND());
        vi.setT$ZTBX009_ITEM$ROUTER(zmdm019.getFIELD44());
        vi.setT$ZTBX009_ITEM$SIZE_MAX(getZtbx008.getSPEC_MAX());
        vi.setT$ZTBX009_ITEM$SIZE_MIN(getZtbx008.getSPEC_MIN());
        vi.setT$ZTBX009_ITEM$IS_DELETESYS("0");
        vi.setT$ZTBX009_ITEM$FBAK04(saveZtbx009Form019.getPO_BATCH());
        Ztbx009Item ztbx009Item = Ztbx009ItemViewUtils.getZtbx009Item(vi);
        listZtbx009Item.add(ztbx009Item);
        BigDecimal resRqBg = remainingQuantityBg.add(bgInputStock);
        getZtbx008.setREMAINING_QUANTITY(resRqBg.toString());
        BigDecimal oldSurpBd = StringUtils.isBlank(getZtbx008.getFBAK04()) ? new BigDecimal("0") : new BigDecimal(getZtbx008.getFBAK04());
        BigDecimal resFbak04 = oldSurpBd.subtract(bgInputStock);
        getZtbx008.setFBAK04(resFbak04.toString());
        this.ztbx008Service.updateZtbx008(getZtbx008);
      } 
      ztbx009.setListZtbx009Item(listZtbx009Item);
      insertZtbx009(ztbx009);
      msg = "改制单号: " + splitZmdm019InsertRes.getPO();
    } catch (MesBusinessException e) {
      throw new RuntimeException(e.getMessage());
    } 
    return msg;
  }
  
  public Result<String> split(Map<String, Object> request) throws MesBusinessException {
    String po = (String)request.get("orderId");
    String poBatch = (String)request.get("orderBatch");
    String finall = (String)request.get("finall");
    String splitType = (String)request.get("splitType");
    Zmdm019 zmdm019 = this.zmdm019Mapper.getZmdm019ByPoAndBatch(po, poBatch);
    if ("SECTION".equals(splitType) || "SECTION_SURPLUS".equals(splitType)) {
      String message = "";
      if (BeanUtil.isEmpty(zmdm019, new String[0]))
        throw new RuntimeCryptoException("根据生产订单号: " + po + "未在生产订单主档表中找到相关信息!"); 
      Zmdm019 newZmdm019 = new Zmdm019();
      String newnumber = getSplitZmdm019(request, zmdm019, newZmdm019);
      this.zmdm019Service.insertZmdm019(newZmdm019);
      zmdm019.setPRD_QTY(finall);
      this.zmdm019Service.updateZmdm019(zmdm019);
      String subMessage = "";
      if ("SECTION_SURPLUS".equals(splitType)) {
        W03OrderDTO w03OrderDTO = new W03OrderDTO();
        w03OrderDTO.setEtrmp(newZmdm019.getENDTIME());
        w03OrderDTO.setStrmp(newZmdm019.getSTARTTIME());
        String poId = newZmdm019.getPO();
        newZmdm019.setPO(poId.replaceFirst("^0+(?!$)", ""));
        w03OrderDTO.setAufnr("00" + newZmdm019.getPO());
        w03OrderDTO.setGamng(newZmdm019.getPRD_QTY());
        w03OrderDTO.setMatnr(newZmdm019.getOUTMARKNO());
        w03OrderDTO.setWerks(newZmdm019.getWERKS());
        w03OrderDTO.setAfart("3");
        w03OrderDTO.setKdauf("");
        w03OrderDTO.setKdpos("");
        w03OrderDTO.setPwerk("9303");
        W03ResDTO w03ResDTO = new W03ResDTO();
        try {
          w03ResDTO = this.w03ControlsService.operationOrder(w03OrderDTO);
          if (Objects.isNull(w03ResDTO))
            throw new RuntimeException("sap返回数据为空"); 
          String type = w03ResDTO.getType();
          if (!"S".equals(type)) {
            message = "对" + newZmdm019.getPO() + "生产订单创建sap订单失败,原因：" + w03ResDTO.getMessage();
            throw new RuntimeException(w03ResDTO.getMessage());
          } 
          String sapPo = w03ResDTO.getRaufnr();
          newZmdm019.setPO(sapPo);
          newZmdm019.setFIELD45("1");
        } catch (Exception e1) {
          e1.printStackTrace();
          throw new RuntimeException(e1.getMessage());
        } 
      } 
      Zmdm020 getZmdm020 = this.zmdm020Service.getZmdm020ByCraftNo(zmdm019.getTPROCESS());
      Zmdm020 zmdm020 = this.zmdm020Service.getZmdm020(getZmdm020.getFCODEID());
      if (BeanUtil.isEmpty(zmdm020, new String[0]))
        throw new RuntimeException("根据生产订单号:" + zmdm019.getPO() + "未找到工艺路线!"); 
      zmdm020.setFCODEID("");
      zmdm020.setPO("");
      this.zmdm020Service.insertZmdm020(zmdm020);
      return Result.ok("订单改制拆分成功！MES订单号：【" + newnumber + "】" + subMessage, newnumber);
    } 
    return null;
  }
  
  private Zmdm019 splitZmdm019(Zmdm019 zmdm019, Map<String, Object> spm, HttpServletRequest httpServletRequest) throws MesBusinessException {
    Zmdm019View viewin = Zmdm019ViewUtils.getZmdm019View(zmdm019);
    viewin.setI$ZMDM019$PRD_QTY(spm.get("finall").toString());
    String splitQty = (new BigDecimal(spm.get("splitNum").toString())).toString();
    if (splitQty.equals(zmdm019.getPRD_QTY())) {
      viewin.setI$ZMDM019$FIELD9("2");
      viewin.setI$ZMDM019$FIELD5("3");
      viewin.setI$ZMDM019$PRD_QTY(splitQty);
      this.zmdm028Mapper.updateIsDeleteByOrderAndBatch(zmdm019.getPO(), zmdm019.getPO_BATCH());
      this.zmdm019Service.updateZmdm019(Zmdm019ViewUtils.getZmdm019(viewin));
      return Zmdm019ViewUtils.getZmdm019(viewin);
    } 
    this.zmdm019Service.updateZmdm019(Zmdm019ViewUtils.getZmdm019(viewin));
    viewin.setI$ZMDM019$PRD_QTY(spm.get("splitNum").toString());
    viewin.setI$ZMDM019$FIELD9("1");
    viewin.setI$ZMDM019$FIELD5("3");
    String tprocess = viewin.getI$ZMDM019$TPROCESS();
    Map<String, Object> cond = new HashMap<>();
    cond.put("craftnoSearch", new String[] { tprocess });
    cond.put("is_deletesysSearch", new String[] { "0" });
    Zmdm020 zmdm020 = this.zmdm020Service.getZmdm020ByCraftNo(tprocess);
    String po_batch = getPo_batch(viewin.getI$ZMDM019$PO(), "1");
    Zmdm020 insertZmdm020GZ = new Zmdm020();
    viewin.setI$ZMDM019$TPROCESS(tprocess);
    String nowUser = SysInfoUtil.getSysUserId(httpServletRequest);
    String userName = SysInfoUtil.getSysUserName(httpServletRequest);
    String time = SysInfoUtil.getSysDateTime();
    viewin.setI$ZMDM019$CURRENTUSERSYS(nowUser);
    viewin.setI$ZMDM019$SALES_ORG(userName);
    viewin.setI$ZMDM019$FCREATER(nowUser);
    viewin.setI$ZMDM019$FCREATEDATE(time);
    viewin.setI$ZMDM019$FCHANGER(nowUser);
    viewin.setI$ZMDM019$FCHANGEDATE(time);
    viewin.setI$ZMDM019$IS_DELETESYS("0");
    viewin.setI$ZMDM019$ISLOCKSTATUSSYS("split");
    viewin.setI$ZMDM019$SHAREROLESYS("");
    viewin.setI$ZMDM019$SHAREUSERSYS("");
    viewin.setI$ZMDM019$SHAREDEPARTMENTSYS("");
    viewin.setI$ZMDM019$SHAREUSERGROUP("");
    viewin.setI$ZMDM019$DIVISION("");
    viewin.setI$ZMDM019$SALES_OFFICE("");
    viewin.setI$ZMDM019$SALES_GROUP("");
    viewin.setI$ZMDM019$SALES_AREA("");
    viewin.setI$ZMDM019$STANDARD("");
    viewin.setI$ZMDM019$PO_BATCH(po_batch);
    Zmdm019 splitZmdm019Insert = Zmdm019ViewUtils.getZmdm019(viewin);
    W03OrderDTO w03OrderDTO = new W03OrderDTO();
    w03OrderDTO.setEtrmp(splitZmdm019Insert.getENDTIME());
    w03OrderDTO.setStrmp(splitZmdm019Insert.getSTARTTIME());
    w03OrderDTO.setAfart(splitZmdm019Insert.getBILLTYPE());
    w03OrderDTO.setWerks(splitZmdm019Insert.getWERKS());
    w03OrderDTO.setKdauf(splitZmdm019Insert.getSO());
    w03OrderDTO.setAufnr("");
    w03OrderDTO.setKdpos(splitZmdm019Insert.getLINE_ITEMNO());
    w03OrderDTO.setMatnr(splitZmdm019Insert.getOUTMARKNO());
    w03OrderDTO.setGamng(splitZmdm019Insert.getPRD_QTY());
    w03OrderDTO.setPwerk("");
    List<SapPoRouteDTO> sapPoRouteDTOList = new ArrayList<>();
    String workCenter = null;
    List<Zmdm020Item> listZmdm020Item = insertZmdm020GZ.getListZmdm020Item();
    for (Zmdm020Item item : listZmdm020Item) {
      SapPoRouteDTO sapPoRouteDTO = new SapPoRouteDTO();
      String processNo = item.getPROCESSNO();
      List<String> workCenters = this.zmdm005Mapper.selectSapCenterNoByProcessNo(processNo);
      if (!CollectionUtil.isEmpty(workCenters)) {
        workCenter = workCenters.get(0);
        sapPoRouteDTO.setWorkCenter(workCenter);
      } 
      if (StringUtils.isBlank(workCenter) || "无".equals(workCenter))
        continue; 
      sapPoRouteDTO.setProcessSeq(item.getPROCESS_LIST());
      sapPoRouteDTO.setFactory(splitZmdm019Insert.getWERKS());
      sapPoRouteDTO.setProcessDesc(item.getPROCESS_NAME());
      sapPoRouteDTO.setControlCode("PP01");
      sapPoRouteDTOList.add(sapPoRouteDTO);
    } 
    w03OrderDTO.setRoutingList(sapPoRouteDTOList);
    W03ResDTO w03ResDTO = new W03ResDTO();
    try {
      w03ResDTO = this.w03ControlsService.operationOrder(w03OrderDTO);
      if (Objects.isNull(w03ResDTO))
        throw new RuntimeException("sap返回数据为空"); 
      String type = w03ResDTO.getType();
      if (!"S".equals(type))
        throw new RuntimeException(w03ResDTO.getMessage()); 
      if (!"".equals(w03ResDTO.getRaufnr())) {
        String orderId = w03ResDTO.getRaufnr();
        String replaceOrder = orderId.replaceFirst("^0+(?!$)", "");
        w03ResDTO.setRaufnr(replaceOrder);
      } 
      splitZmdm019Insert.setPO(w03ResDTO.getRaufnr());
      splitZmdm019Insert.setFBAK01(w03ResDTO.getRbatch());
    } catch (Exception e1) {
      e1.printStackTrace();
      throw new RuntimeException(e1.getMessage());
    } 
    if (!BeanUtil.isEmpty(zmdm020, new String[0])) {
      Zmdm020 zmdm0202 = this.zmdm020Service.getZmdm020(zmdm020.getFCODEID());
      zmdm0202.setPO(splitZmdm019Insert.getPO());
      zmdm0202.setPO_BATCH(po_batch);
      insertZmdm020GZ = this.zmdm020Service.insertZmdm020(zmdm0202);
      tprocess = zmdm0202.getCRAFTNO();
      this.zmdm020Mapper.resetCompletionInformation(tprocess);
    } 
    Zmdm019 splitZmdm019InsertRes = this.zmdm019Service.insertZmdm019(splitZmdm019Insert);
    return splitZmdm019InsertRes;
  }
  
  private String splitZmdm0192(Zmdm019 zmdm019, Map<String, Object> spm, HttpServletRequest httpServletRequest) throws MesBusinessException {
    String nowUser = SysInfoUtil.getSysUserId(httpServletRequest);
    String userName = SysInfoUtil.getSysUserName(httpServletRequest);
    String time = SysInfoUtil.getSysDateTime();
    String splitQty = (new BigDecimal(spm.get("splitNum").toString())).toString();
    List<Zmdm019> zmdm019s = this.zmdm019Mapper.getZmdm019ByPoBatch(zmdm019.getPO(), "901");
    Zmdm019View viewin = Zmdm019ViewUtils.getZmdm019View(zmdm019);
    if (CollectionUtil.isNotEmpty(zmdm019s)) {
      Zmdm019 zmdm019901 = zmdm019s.get(0);
      if (splitQty.equals(zmdm019.getPRD_QTY())) {
        zmdm019.setFIELD9("2");
        zmdm019.setPRD_QTY("0");
        this.zmdm019Service.updateZmdm019(zmdm019);
        this.zmdm028Mapper.updateIsDeleteByOrderAndBatch(zmdm019.getPO(), zmdm019.getPO_BATCH());
      } 
      BigDecimal prdQty = new BigDecimal(zmdm019901.getPRD_QTY());
      BigDecimal splitQty2 = new BigDecimal(spm.get("splitNum").toString());
      String resPrdQtyStr = prdQty.add(splitQty2).toString();
      zmdm019901.setPRD_QTY(resPrdQtyStr);
      zmdm019901.setFCHANGER(nowUser);
      zmdm019901.setFCHANGEDATE(time);
      this.zmdm019Service.updateZmdm019(zmdm019901);
      return zmdm019901.getPO_BATCH();
    } 
    if (StringUtils.isNotBlank(splitQty) && StringUtils.isNotBlank(viewin.getI$ZMDM019$PRD_QTY()) && splitQty.equals(viewin.getI$ZMDM019$PRD_QTY())) {
      viewin.setI$ZMDM019$FIELD9("2");
      viewin.setI$ZMDM019$PRD_QTY("0");
    } else {
      viewin.setI$ZMDM019$PRD_QTY(spm.get("finall").toString());
    } 
    this.zmdm019Service.updateZmdm019(Zmdm019ViewUtils.getZmdm019(viewin));
    viewin.setI$ZMDM019$PRD_QTY(spm.get("splitNum").toString());
    viewin.setI$ZMDM019$FIELD9("1");
    viewin.setI$ZMDM019$FIELD5("3");
    String tprocess = viewin.getI$ZMDM019$TPROCESS();
    Map<String, Object> cond = new HashMap<>();
    cond.put("craftnoSearch", new String[] { tprocess });
    cond.put("is_deletesysSearch", new String[] { "0" });
    Zmdm020 zmdm020 = this.zmdm020Service.getZmdm020ByCraftNo(tprocess);
    String po_batch = getPo_batch(viewin.getI$ZMDM019$PO(), "1");
    if (!BeanUtil.isEmpty(zmdm020, new String[0])) {
      Zmdm020 zmdm0202 = this.zmdm020Service.getZmdm020(zmdm020.getFCODEID());
      zmdm0202.setPO_BATCH(po_batch);
      this.zmdm020Service.insertZmdm020(zmdm0202);
      tprocess = zmdm0202.getCRAFTNO();
      this.zmdm020Mapper.resetCompletionInformation(tprocess);
    } 
    viewin.setI$ZMDM019$TPROCESS(tprocess);
    viewin.setI$ZMDM019$CURRENTUSERSYS(nowUser);
    viewin.setI$ZMDM019$SALES_ORG(userName);
    viewin.setI$ZMDM019$FCREATER(nowUser);
    viewin.setI$ZMDM019$FCREATEDATE(time);
    viewin.setI$ZMDM019$FCHANGER(nowUser);
    viewin.setI$ZMDM019$FCHANGEDATE(time);
    viewin.setI$ZMDM019$IS_DELETESYS("0");
    viewin.setI$ZMDM019$ISLOCKSTATUSSYS("split");
    viewin.setI$ZMDM019$SHAREROLESYS("");
    viewin.setI$ZMDM019$SHAREUSERSYS("");
    viewin.setI$ZMDM019$SHAREDEPARTMENTSYS("");
    viewin.setI$ZMDM019$SHAREUSERGROUP("");
    viewin.setI$ZMDM019$DIVISION("");
    viewin.setI$ZMDM019$SALES_OFFICE("");
    viewin.setI$ZMDM019$SALES_GROUP("");
    viewin.setI$ZMDM019$SALES_AREA("");
    viewin.setI$ZMDM019$STANDARD("");
    viewin.setI$ZMDM019$PO_BATCH(po_batch);
    Zmdm019 insertZmdm019 = this.zmdm019Service.insertZmdm019(Zmdm019ViewUtils.getZmdm019(viewin));
    return insertZmdm019.getPO_BATCH();
  }
  
  private String getPo_batch(String PO, String typ) {
    if (PO == null || PO.equals(""))
      return "001"; 
    String pobatch = "";
    if (typ.equals("0")) {
      pobatch = this.zmdm019Mapper.getNormalMaxBatch(PO);
    } else {
      pobatch = this.zmdm019Mapper.getReformMaxBatch(PO);
    } 
    if (pobatch != null && !pobatch.equals(""))
      return String.format("%03d", new Object[] { Integer.valueOf(Integer.parseInt(pobatch)) }); 
    if (typ.equals("0"))
      return "001"; 
    return "901";
  }
  
  private String getSplitZmdm019(Map<String, Object> request, Zmdm019 zmdm019, Zmdm019 newZmdm019) {
    BeanUtil.copyProperties(zmdm019, newZmdm019, new String[0]);
    String po = (String)request.get("orderId");
    String poBatch = (String)request.get("orderBatch");
    String finall = (String)request.get("finall");
    String orderType = (String)request.get("orderType");
    String splitNum = (String)request.get("splitNum");
    String splitType = (String)request.get("splitType");
    String userId = (String)request.get("userId");
    String newOrderId = "";
    newZmdm019.setFIELD5("3");
    "3".equals(orderType);
    newZmdm019.setFIELD9("1");
    newZmdm019.setSTARTTIME(DateTime.now().toDateStr());
    newZmdm019.setENDTIME(zmdm019.getENDTIME());
    newZmdm019.setPRD_QTY(splitNum);
    newZmdm019.setIS_DELETESYS("0");
    newZmdm019.setFCREATER(userId);
    String time = DateUtil.now();
    newZmdm019.setFCREATEDATE(time);
    newZmdm019.setFCHANGER(userId);
    newZmdm019.setFCHANGEDATE(time);
    return newOrderId;
  }
  
  public String approved(String mainPk, String itemPks, String userId) {
    int successCount = 0;
    int errorCount = 0;
    StringBuffer errorMsg = new StringBuffer();
    Ztbx009 ztbx009 = getZtbx009(mainPk);
    String[] pkArray = itemPks.split(",");
    for (int i = 0; i < pkArray.length; i++) {
      try {
        Ztbx009Item ztbx009Item = this.ztbx009Mapper.getZtbx009Item(pkArray[i]);
        String stockPk = ztbx009Item.getSTOCK_PK();
        Ztbx008 ztbx008 = this.ztbx008Service.getZtbx008(stockPk);
        BigDecimal nw = new BigDecimal(ztbx009Item.getNW());
        BigDecimal now_nw = new BigDecimal(ztbx008.getSTOCK());
        BigDecimal new_nw = now_nw.subtract(nw);
        BigDecimal remainingQuantity = new BigDecimal(ztbx008.getREMAINING_QUANTITY());
        BigDecimal remainingQuantityRes = remainingQuantity.subtract(nw);
        if (new_nw.compareTo(BigDecimal.ZERO) < 0) {
          String msg = "库存主键=" + stockPk + "，扣减后库存短缺" + new_nw.abs() + ",请检查!";
          errorMsg.append(msg);
          errorCount++;
        } else {
          GoodsMovementDTO goodsMovementDTO = new GoodsMovementDTO();
          goodsMovementDTO.setBudat(ztbx009.getPOSTING_DATE());
          goodsMovementDTO.setBldat(ztbx009.getPOSTING_DATE());
          goodsMovementDTO.setUname(userId);
          goodsMovementDTO.setBktxt(userId);
          goodsMovementDTO.setGcode("03");
          goodsMovementDTO.setBwart("261");
          List<GoodsmvtItem> goodsmvtItems = new ArrayList<>();
          GoodsmvtItem item = new GoodsmvtItem();
          item.setMatnr(ztbx008.getMAT());
          item.setWerks("9303");
          item.setLgort("7005");
          item.setCharg(ztbx008.getSAP_BATCH());
          item.setSobkz("");
          item.setMenge(ztbx009Item.getNW());
          item.setMeins("KG");
          item.setAufnr(ztbx009.getSAP_PO());
          goodsmvtItems.add(item);
          goodsMovementDTO.setGoodsmvtItems(goodsmvtItems);
          SapProductionmovementExecuteSoapBiz_PTBindingQSServiceStub.Z_JT_FUN_W18_RESPONSE goodsMoveW18 = this.goodsMovementService.goodsMoveW18(goodsMovementDTO);
          if (!"S".equals(goodsMoveW18.getR_LOG().getTYPE().toString())) {
            System.out.println(goodsMoveW18.getR_LOG().getMESSAGE().toString());
            errorMsg.append(goodsMoveW18.getR_LOG().getMESSAGE().toString());
            errorCount++;
            this.ztbx009Mapper.updateItemStatusByItemPk(pkArray[i], "2", goodsMoveW18.getR_LOG().getMESSAGE().toString());
          } else {
            ztbx009.setREVIEW_STATUS("1");
            List<Ztbx009Item> itemList = ztbx009.getListZtbx009Item();
            itemList.stream().forEach(it -> {
                  it.setSYNCZ_STATUS("1");
                  it.setSYNCZ_NOTE(paramZ_JT_FUN_W18_RESPONSE.getR_LOG().getMESSAGE().toString());
                });
            ztbx009.setListZtbx009Item(itemList);
            updateZtbx009(ztbx009);
            ztbx008.setSTOCK(new_nw.toString());
            ztbx008.setREMAINING_QUANTITY(remainingQuantityRes.toString());
            this.ztbx008Service.updateZtbx008(ztbx008);
            successCount++;
          } 
        } 
      } catch (Exception e) {
        e.printStackTrace();
        errorMsg.append(e.getMessage());
        errorCount++;
      } 
    } 
    String resultMSG = "共通过" + pkArray.length + "条;<br>通过成功" + successCount + "条;<br>";
    if (errorCount > 0)
      resultMSG = String.valueOf(resultMSG) + "通过失败" + errorCount + "条;<br>异常信息:" + errorMsg; 
    return resultMSG;
  }
  
  public String reviewFailed(String mainPk, String itemPks, String userId) {
    int successCount = 0;
    int errorCount = 0;
    Ztbx009 ztbx009 = getZtbx009(mainPk);
    String[] pkArray = itemPks.split(",");
    for (int i = 0; i < pkArray.length; i++) {
      try {
        Ztbx009Item ztbx009Item = this.ztbx009Mapper.getZtbx009Item(pkArray[i]);
        String stockPk = ztbx009Item.getSTOCK_PK();
        Ztbx008 ztbx008 = this.ztbx008Service.getZtbx008(stockPk);
        BigDecimal nw = new BigDecimal(ztbx009Item.getNW());
        BigDecimal surplus_nw = new BigDecimal(ztbx008.getREMAINING_QUANTITY());
        BigDecimal new_nw = surplus_nw.subtract(nw);
        ztbx008.setFBAK04((new BigDecimal(ztbx008.getFBAK04())).add(nw).toString());
        ztbx008.setREMAINING_QUANTITY(new_nw.toString());
        this.ztbx009Mapper.updateItemStatusByItemPk(pkArray[i], "3", "");
        this.ztbx008Service.updateZtbx008(ztbx008);
      } catch (Exception e) {
        e.printStackTrace();
        errorCount++;
      } 
      successCount++;
    } 
    String resultMSG = "共驳回" + pkArray.length + "条;<br>驳回成功" + successCount + "条;<br>";
    if (errorCount > 0)
      resultMSG = String.valueOf(resultMSG) + "驳回失败" + errorCount + "条;"; 
    ztbx009.setREVIEW_STATUS("2");
    updateZtbx009(ztbx009);
    return resultMSG;
  }
}
